Imports System
Imports System.Collections.Specialized
Imports System.Text.RegularExpressions

Public Class Arguments

    Private Parameters As StringDictionary

    Public Sub New(ByVal Args As String())
        Parameters = New StringDictionary()
        Dim Spliter As Regex = New Regex("^-{1,2}|^/|=", RegexOptions.IgnoreCase Or RegexOptions.Compiled)

        Dim Remover As New Regex("^['""]?(.*?)['""]?$", RegexOptions.IgnoreCase Or RegexOptions.Compiled)

        Dim Parameter As String = Nothing
        Dim Parts() As String

        ' Valid parameters forms:
        ' {-,/,--}param{ ,=,:}((",')value(",'))
        ' Examples: 
        ' -param1 value1 --param2 /param3:"Test-:-work" 
        '   /param4=happy -param5 '--=nice=--'
        Dim Txt As String
        For Each Txt In Args
            ' Look for new parameters (-,/ or --) and a
            ' possible enclosed value (=,:)
            Parts = Spliter.Split(Txt, 3)

            Select Case Parts.Length
                ' Found a value (for the last parameter 
                ' found (space separator))
                Case 1
                    If Not IsNothing(Parameter) Then
                        Parts(0) = Remover.Replace(Parts(0), "$1")
                        Parameters(Parameter) &= IIf(Parameters(Parameter) = "", "", " ") & Parts(0)
                    End If
                    ' else Error: no parameter waiting for a value (skipped)
                    Exit Select

                    ' Found just a parameter
                Case 2
                    Parameter = Parts(1)
                    If Parameter = "V" Then Parameter = "version"
                    If Not IsNothing(Parameter) Then
                        If (Not Parameters.ContainsKey(Parameter)) Then
                            Parameters.Add(Parameter, "")
                        End If
                    End If
                    Exit Select

                    ' Parameter with enclosed value
                Case 3
                    ' Remove possible enclosing characters (",')
                    If Not IsNothing(Parameter) Then
                        Parts(2) = Remover.Replace(Txt, "$1")
                        Parameters(Parameter) &= IIf(Parameters(Parameter) = "", "", " ") & Parts(2)
                    End If

                    Exit Select
            End Select
        Next
        ' In case a parameter is still waiting
        If Not IsNothing(Parameter) Then
            If (Not Parameters.ContainsKey(Parameter)) Then
                Parameters.Add(Parameter, "")
            End If
        End If
    End Sub

    Default Public ReadOnly Property arguments(ByVal Param As String) As String
        Get
            Return Parameters(Param)
        End Get
    End Property


End Class
